function getTransitionEndName(){
    // Find correct transitionend event name for browser
    var t
    var el = document.createElement('fakeelement')
    var transitions = {
        transition: 'transitionend',
        OTransition: 'oTransitionEnd',
        MozTransition :'transitionend',
        WebkitTransition: 'webkitTransitionEnd'
    }

    for (t in transitions) {
        if (el.style[t] !== undefined) {
            return transitions[t]
        }
    }
}

export default {
    install (Vue, options) {
        const transitionEndName = getTransitionEndName()
    
        Vue.prototype.$nextTransitionEnd = function (callback, element) {
            const el = element || this.$el
            const eventListener = event => {
                // Only run once.
                // This will catch transition events from child nodes. Be sure to specify lowest level element.
                el.removeEventListener(transitionEndName, eventListener)
                callback(event)
            }
            el.addEventListener(transitionEndName, eventListener)
        }
    
        Vue.prototype.$onTransitionEnd = function (callback, element) {
            const el = element || this.$el
            el.addEventListener(transitionEndName, callback)
        }
    }
}
